import chat.Main;
import chat.MessageBox;
import org.aswing.JFrame;
import org.aswing.JButton;
import org.aswing.JTextField;
import org.aswing.JLabel;
import org.aswing.JPanel;
import org.aswing.Event;
import org.aswing.BorderLayout;
import org.aswing.FlowLayout ;
import org.aswing.BoxLayout;



class chat.LoginWindow extends JFrame
{
	//Button for submitting the desired user name
	private var _submit_btn:JButton;
	//Button for clearing the textfield
	private var _clear_btn:JButton;
	//Label and textfield for username 
	private var _userName_lbl:JLabel;
	//TextField for user to  input name
	private var _userName_txt:JTextField;
	//Event name for when the user clicks on the submit button.
	private static var _onSubmit:String="ON_SUBMIT";
	
	
	public function LoginWindow(owner:JFrame,title:String , modal:Boolean){		
		//Call the super constructor
		super(owner , title , modal);
		//set the size
		setSize(300,150);
		//set the position
		setLocation(200,200);		
		//make the window not closable
		setClosable(false);
		//make the window not resizable
		setResizable(false);
		// make the window visible.
		setVisible(true);
		//Set new layout 
		getContentPane().setLayout(new BorderLayout(5,5));
		//call function to build rest of the gui
		buildGUI();
	}
		
	private function buildGUI(Void):Void{
		
		//Creating and setting properties for the label component
		_userName_lbl = new JLabel ("Username : ");
		_userName_lbl.setHorizontalAlignment(JLabel.LEFT);
		
		//Creating and setting properties for the textfield component
		_userName_txt = new JTextField("",30);
		_userName_txt.setPreferredSize(150,22);
		
		
		//Creating and setting properties for the submit button
		_submit_btn = new JButton("Submit");
		_submit_btn.setPreferredSize(80,22);
		_submit_btn.setToolTipText("Log on to the chat server.");
		_submit_btn.addEventListener(JButton.ON_CLICKED , fireOnClickEvent, this);
		
		//Creating and setting properties for the clear button
		_clear_btn = new JButton("Clear");
		_clear_btn.setPreferredSize(80,22);
		_clear_btn.setToolTipText("Clear the username.");
		_clear_btn.addEventListener(JButton.ON_CLICKED,clearUserName,this);
		
		//Create the top panel which will contain the label
		var topPane:JPanel=new JPanel();
		topPane.setLayout(new BorderLayout(5,5));
		topPane.append(_userName_lbl,BorderLayout.NORTH);
		
		//Create the center panel which will contain the textfield
		var centerPane:JPanel=new JPanel();
		centerPane.setLayout(new BorderLayout(5,5));		
		centerPane.append(_userName_txt,BorderLayout.NORTH);
		
		////Create the top panel which will contain the submit and clear button
		var bottomPane:JPanel=new JPanel();
		bottomPane.setLayout(new FlowLayout(FlowLayout.RIGHT,20,8));
		bottomPane.append(_submit_btn);
		bottomPane.append(_clear_btn);
		
		//Add panels to the main frame window
		getContentPane().append(topPane,BorderLayout.NORTH);
		getContentPane().append(centerPane,BorderLayout.CENTER);
		getContentPane().append(bottomPane,BorderLayout.SOUTH);
	}
	
	
	private function fireOnClickEvent(eventObj:Event):Void{
		if(_userName_txt.getText()==""){			
			var msgBox:MessageBox=new MessageBox(this,"Error","Please enter a user name.",true);
			msgBox.setVisible(true);
		}
		else{
			dispatchEvent(createEventObj(ON_SUBMIT));
		}
	}
	
	private function clearUserName(eventObj:Event):Void{		
		_userName_txt.setText("");		
	}
	
	public static function get ON_SUBMIT():String{
		return _onSubmit;
	}
	
	public function getUserName(Void):String{
		return _userName_txt.getText();
		
	}
	
}
